.nolist
include \masm32\include\masm32rt.inc

.686
.xmm

; ###### these macros improve drastically the consistency of timings on the P4 #######
include Cyct_Macros.inc

 l_htodw	PROTO : DWORD
 l_a2l       proto :dword 
Axhex2dw  PROTO : DWORD
Axa2l   proto :dword 
z_htodw PROTO :DWORD

Axhex2dw_Unrolled PROTO:DWORD
Hex2BinSSE2a	PROTO:DWORD
Hex2BinSSE2b	PROTO:DWORD
Hex2BinSSE2c	PROTO:DWORD
Hex2BinSSE2d	PROTO:DWORD
Hex2BinSSE2e	PROTO:DWORD
Hex2BinDrizzMMX	PROTO:DWORD
Hex2BinDrizzSSE1	PROTO:DWORD
Hex2dwLingoSSE  PROTO:DWORD

UseLingoOLD = 0

.data

align  16
; hexstring    db  "AbCdEf78", 0
; hexstring    db  "aBcDeF78", 0
hexstring    db  "AbCdEf78", 13, 10, 0, "xxxxxx"
; hexstring    db  "AbCdEf78", 13, 10, 0, "xxxxxx"	; fails for Masm32 htodw
; hexstring    db  "ABC", 0			; not 8 chars
; hexstring    db  "ABCDEF78",0	; jq4

Magic = 0AbCdEf78h

align 16
mask39h dq 3939393939393939h
maskFFh dq 00FF00FF00FF00FFh
maskD0h dq 0D0D0D0D0D0D0D0D0h
maskF9h dq 0F9F9F9F9F9F9F9F9h
mask0Fh dq 0F0F0F0F0F0F0F0Fh
mask30h dq 3030303030303030h


if UseLingoOLD
align 16
tabl1	dd 0,1,2,3,4,5,6,7,8,9
	dd 39 Dup(0)
	dd 0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh
tabl1_end	dd 0
endif

.code
start:
	invoke GetCurrentThread
	invoke SetThreadAffinityMask,eax,1
	invoke Sleep,0
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	
	print "Case-insensitive conversion of 8-byte hex string to eax", 13, 10, 10

	invoke htodw, addr  hexstring
	.if eax!=Magic
		print hex$(eax), 9, " for htodw", 13, 10
	.endif
	invoke l_htodw, addr  hexstring
	.if eax!=Magic
		print hex$(eax), 9, " for l_htodw", 13, 10
	.endif
	invoke Axhex2dw_Unrolled, addr  hexstring
	.if eax!=Magic
		print hex$(eax), 9, " for Axhex2dw_Unrolled", 13, 10
	.endif
;	invoke Hex2BinSSE2a, addr  hexstring
;	.if eax!=Magic
;		print hex$(eax), 9, " for Hex2BinSSE2a", 13, 10
;	.endif
;	invoke Hex2BinSSE2b, addr  hexstring
;	.if eax!=Magic
;		print hex$(eax), 9, " for Hex2BinSSE2b", 13, 10
;	.endif
;	invoke Hex2BinSSE2c, addr  hexstring
;	.if eax!=Magic
;		print hex$(eax), 9, " for Hex2BinSSE2c", 13, 10
;	.endif
;	invoke Hex2BinSSE2d, addr  hexstring
;	.if eax!=Magic
;		print hex$(eax), 9, " for Hex2BinSSE2d", 13, 10
;	.endif
	invoke Hex2BinSSE2e, addr  hexstring
	.if eax!=Magic
		print hex$(eax), 9, " ** for Hex2BinSSE2e", 13, 10
	.endif
	invoke Hex2dwLingoSSE, addr  hexstring
	.if eax!=Magic
		print hex$(eax), 9, "for Hex2dwLingoSSE", 13, 10
	.endif



;	fldpi
;	fld1
;	fldz
;	int 3
	invoke Hex2BinDrizzMMX, addr  hexstring		; trashes 5 FPU registers
;	emms
;	.if eax!=Magic
;		print hex$(eax), 9, " for Hex2BinDrizzMMX", 13, 10
;	.endif
;	finit
;	fldpi
;	fld1
;	fldz
;	int 3
;	invoke Hex2BinDrizzSSE1, addr  hexstring
;	.if eax!=Magic
;		print hex$(eax), 9, " for Hex2BinDrizzSSE1", 13, 10
;	.endif

	REPEAT 2

	cyct_begin
		invoke htodw, addr  hexstring
	cyct_end <htodw (Masm32)>

	cyct_begin
		invoke l_htodw, addr  hexstring
	if UseLingoOLD
		cyct_end <l_htodw, old version>
	else
		cyct_end <l_htodw, new version>
	endif

	cyct_begin	
		invoke Axhex2dw_Unrolled, addr  hexstring
	cyct_end <Axhex2dw_Unrolled>
	
;	cyct_begin	
;		invoke Axhex2dw, addr  hexstring
;	cyct_end <Axhex2dw>

;	cyct_begin	
;		invoke Hex2BinSSE2a, addr  hexstring
;	cyct_end <Hex2BinSSE2a>

;	cyct_begin	
;		invoke Hex2BinSSE2b, addr  hexstring
;	cyct_end <Hex2BinSSE2b>

;	cyct_begin
;		invoke Hex2BinSSE2c, addr  hexstring
;	cyct_end <Hex2BinSSE2c>

;	cyct_begin
;		invoke Hex2BinSSE2d, addr  hexstring
;	cyct_end <Hex2BinSSE2d>

	cyct_begin	
		invoke Hex2BinSSE2e, addr  hexstring
	cyct_end <** Hex2Bin2e>

;	cyct_begin
;		invoke Hex2BinDrizzSSE1, addr  hexstring
;	cyct_end <Hex2BinDrizzSSE1>

;	cyct_begin
;		invoke Hex2BinDrizzMMX, addr  hexstring
;	cyct_end <Hex2BinDrizzMMX>

	cyct_begin
		invoke 	Hex2dwLingoSSE, addr  hexstring
	cyct_end <Hex2dwLingoSSE>




	print chr$(13, 10)
	ENDM
	
	print "Codesizes:", 13, 10
	print "l_htodw - Lingo:", 9
	mov   eax, l_htodw_endp
	sub	  eax, l_htodw_s
	if UseLingoOLD
		add eax, offset tabl1_end
		sub eax, offset tabl1
	endif
	print str$(eax), 13, 10

	print "Axhex2dw Unro - Alex:", 9
	mov   eax, Axhex2dw_endp_Unrolled
	sub	  eax, Axhex2dw_Unrolled
	add eax, offset @table_end
	sub eax, offset @table
	print str$(eax), 13, 10
	
	print "Axhex2dw - Alex:", 9
	mov   eax, Axhex2dw_endp
	sub	  eax, Axhex2dw
	print str$(eax), 13, 10

;	print "Hex2BinSSE2a - Jochen:", 9
;	mov   eax, Hex2BinSSE2a_endp
;	sub	  eax, Hex2BinSSE2a_s
;	print str$(eax), 13, 10

;	print "Hex2BinSSE2b - Jochen:", 9
;	mov   eax, Hex2BinSSE2b_endp
;	sub	  eax, Hex2BinSSE2b_s
;	print str$(eax), 13, 10

;	print "Hex2BinSSE2c - Jochen:", 9
;	mov   eax, Hex2BinSSE2c_endp
;	sub	  eax, Hex2BinSSE2c_s
;	print str$(eax), 13, 10

;	print "Hex2BinSSE2d - Jochen:", 9
;	mov   eax, Hex2BinSSE2d_endp
;	sub	  eax, Hex2BinSSE2d_s
;	print str$(eax), 13, 10

	print "Hex2BinSSE2e - Jochen:", 9
	mov   eax, Hex2BinSSE2e_endp
	sub	  eax, Hex2BinSSE2e_s
	print str$(eax), 13, 10

;	print "Hex2BinMMX - drizz:", 9
;	mov   eax, Hex2BinDrizzMMX_endp
;	sub	  eax, Hex2BinDrizzMMX_s
;	print str$(eax), 13, 10

;	print "Hex2BinSSE1 - drizz:", 9
;	mov   eax, Hex2BinDrizzSSE1_endp
;	sub	  eax, Hex2BinDrizzSSE1_s
;	print str$(eax), 13, 10


	print "Hex2dwLingoSSE - Lingo:", 9
	mov   eax, Hex2dwLingoSSE_endp
	sub	  eax, Hex2dwLingoSSE_s
	print str$(eax), 13, 10
	
	inkey "--- ok ---"
	exit


push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

option prologue:none
option epilogue:none	
align 16
if UseLingoOLD
l_htodw_s:
db 0,0,0,0,0,0,0,0
l_htodw   proc lpString:dword
	mov		edx, [esp+4]
	mov		eax, 11011111Y		; corrected by JJ
	and      eax, [edx]
	mov		ecx, 11011111Y 
	jz			@f
	mov		eax, [tabl1+eax*4-40h]
	and      ecx, [edx+1]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+2]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+3]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+4]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+5]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+6]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+7]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
@@:
	ret		4
l_htodw  endp
l_htodw_endp:
endif

align 16

db 0CCh,0CCh,0CCh,0CCh ; shifting to align main loop at 16 bytes
Axhex2dw    proc STDCALL lpszStr:DWORD
	mov edx,[esp+4]
	xor eax,eax
	mov [esp+4],edi
	
	jmp @preloop
	
	; main loop
	@@:	; loop aligned by 16 bytes
	and edi,1111Y
	shr ecx,6
	add edx,1
	shl eax,4
	lea edi,[edi+ecx*8]
	add eax,ecx
	add eax,edi
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx edi,byte ptr [edx]
	cmp ecx,0
	jnz @B
	@done:
	mov edi,[esp+4]
	ret 4
Axhex2dw    endp
Axhex2dw_endp:

align 16
Axhex2dw_Unrolled    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]

	UNIT TEXTEQU <DWORD>
	
	@l1:
	movzx ecx,byte ptr [edx]
	cmp ecx,0
	jz @done
	mov eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+1]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+2]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+3]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+4]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+5]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+6]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+7]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	ret 4
	


	@done:
	shr eax,4
	ret 4

	.data
	align 16
	@table label UNIT
	;UNIT 30h dup (-1)
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
	@table_end label UNIT
	.code _TEXT
		
Axhex2dw_Unrolled    endp
Axhex2dw_endp_Unrolled:

	mov eax, "a"
	and eax, 63+32	; 95, 5Fh
	print hex$(eax), 13, 10

align 16
Hex2BinSSE2a_s:
h2bUseMem =	1
	if h2bUseMem
		jq1	dq	0039003900390039h, 0039003900390039h	; 8* "9"
		jq2	dq	0027002700270027h, 0027002700270027h	; 8* 7
		jq3	dq	0030003000300030h, 0030003000300030h	; 8* "0"
		jq4	dq	0020002000200020h, 0020002000200020h	; lowercase
	endif
Hex2BinSSE2a proc src
	push esi
	push ecx	; preserves ecx
	mov esi, [esp+12]
	if h2bUseMem
		mov edx, offset jq1
	endif
	dd 0E7E0FF3h	; aka movq xmm1, [esi] (fixes a masm 8+ bug)
	xorps xmm0, xmm0	; xmm0 may contain garbage
	punpcklbw xmm0, xmm1	; expand 8 bytes to 8 xmm0 words
;	abcdef78
	pshuflw xmm0, xmm0, 01110010b	; see [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc265.htm]punpcklbw[/url] and [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc253.htm]pshuflw[/url]
;	cadb
	pshufhw xmm0, xmm0, 01110010b
;	cadb7e8f
	pshufd xmm0, xmm0, 00100111b	; CDAB78EF
;	8fdb7eca	; for eax=ABCDEF78
	psrlq xmm0, 8	; shift right by one byte
	movdqa xmm1, xmm0
	if h2bUseMem
		pcmpgtb xmm1, [edx+0]	; jq1 - get info which items are letters
		pand xmm1, [edx+16]	; jq2 - prepare for subtracting extra 7
		paddb xmm1, [edx+32]	; jq3 - load either 30h or 37h
		por xmm0, [edx+48]	; jq4 - convert to lowercase
	else
		mov eax, 00390039h
		movd xmm2, eax
		pshufd xmm2, xmm2, 0
		pcmpgtb xmm1, xmm2	; jq1 - get info which items are letters
		mov eax, 00270027h
		movd xmm2, eax
		pshufd xmm2, xmm2, 0
		pand xmm1, xmm2	; jq2 - prepare for subtracting extra 7
		mov eax, 00300030h
		movd xmm2, eax
		pshufd xmm2, xmm2, 0
		paddb xmm1, xmm2	; jq3 - load either 30h or 37h
		mov eax, 00200020h
		movd xmm2, eax
		pshufd xmm2, xmm2, 0
		por xmm0, xmm2	; jq4 - convert to lowercase
	endif
	psubb xmm0, xmm1	; subtract from bytes in string
	packsswb xmm0, xmm0	; pack words to bytes
	movdqa xmm1, xmm0
	psrlq xmm0, 7*4	; shift right by seven nibbles
	if 0		; 2 bytes longer, same speed
		movd eax, xmm0	; eax: a0c0e070
		movd edx, xmm1	; edx: b0d0f080
		or eax, edx
		else
		por xmm0, xmm1
		movd eax, xmm0	; ecx: abcdef78
		endif
	pop ecx
	pop esi
	ret 4
Hex2BinSSE2a endp
Hex2BinSSE2a_endp:

align 16
Hex2BinSSE2b_s:
h2bUseMem =	0
	if h2bUseMem
		jq1	dq	0039003900390039h, 0039003900390039h	; 8* "9"
		jq2	dq	0027002700270027h, 0027002700270027h	; 8* 7
		jq3	dq	0030003000300030h, 0030003000300030h	; 8* "0"
		jq4	dq	0020002000200020h, 0020002000200020h	; lowercase
	endif
Hex2BinSSE2b proc src
	push esi
	push ecx	; preserves ecx
	mov esi, [esp+12]
	if h2bUseMem
		mov edx, offset jq1
	endif
	dd 0E7E0FF3h	; aka movq xmm1, [esi] (fixes a masm 8+ bug)
	xorps xmm0, xmm0	; xmm0 may contain garbage
	punpcklbw xmm0, xmm1	; expand 8 bytes to 8 xmm0 words
;	abcdef78
	pshuflw xmm0, xmm0, 01110010b	; see [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc265.htm]punpcklbw[/url] and [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc253.htm]pshuflw[/url]
;	cadb
	pshufhw xmm0, xmm0, 01110010b
;	cadb7e8f
	pshufd xmm0, xmm0, 00100111b	; CDAB78EF
;	8fdb7eca	; for eax=ABCDEF78
	psrlq xmm0, 8	; shift right by one byte
	movdqa xmm1, xmm0
	if h2bUseMem
		pcmpgtb xmm1, [edx+0]	; jq1 - get info which items are letters
		pand xmm1, [edx+16]	; jq2 - prepare for subtracting extra 7
		paddb xmm1, [edx+32]	; jq3 - load either 30h or 37h
		por xmm0, [edx+48]	; jq4 - convert to lowercase
	else
		mov eax, 00390039h
		movd xmm2, eax
		pshufd xmm2, xmm2, 0
		pcmpgtb xmm1, xmm2	; jq1 - get info which items are letters
		mov eax, 00270027h
		movd xmm2, eax
		pshufd xmm2, xmm2, 0
		pand xmm1, xmm2	; jq2 - prepare for subtracting extra 7
		mov eax, 00300030h
		movd xmm2, eax
		pshufd xmm2, xmm2, 0
		paddb xmm1, xmm2	; jq3 - load either 30h or 37h
		mov eax, 00200020h
		movd xmm2, eax
		pshufd xmm2, xmm2, 0
		por xmm0, xmm2	; jq4 - convert to lowercase
	endif
	psubb xmm0, xmm1	; subtract from bytes in string
	packsswb xmm0, xmm0	; pack words to bytes
	movdqa xmm1, xmm0
	psrlq xmm0, 7*4	; shift right by seven nibbles
	if 0		; 2 bytes longer, same speed
		movd eax, xmm0	; eax: a0c0e070
		movd edx, xmm1	; edx: b0d0f080
		or eax, edx
		else
		por xmm0, xmm1
		movd eax, xmm0	; ecx: abcdef78
		endif
	pop ecx
	pop esi
	ret 4
Hex2BinSSE2b endp
Hex2BinSSE2b_endp:

align 16
Hex2BinSSE2c_s:
jq1c	dq 0039003900390039h, 0039003900390039h	; 8* "9"
jq2c	dq 0009000900090009h, 0009000900090009h	; 8* 9
jq3c	dq 0030003000300030h, 0030003000300030h	; 8* "0"
jq4c	dq 000F000F000F000Fh, 000F000F000F000Fh	; lowercase
Hex2BinSSE2c proc src
	push esi
	mov esi, [esp+8]
	mov edx, offset jq1c
	xorps xmm0, xmm0	; xmm0 may contain garbage
	dd 0E7E0FF3h	; aka movq xmm1, [esi] (fixes a masm 8+ bug)
	punpcklbw xmm0, xmm1	; expand 8 bytes to 8 xmm0 words
;	abcdef78
	pshuflw xmm0, xmm0, 01110010b	; see [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc265.htm]punpcklbw[/url] and [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc253.htm]pshuflw[/url]
;	cadb
	pshufhw xmm0, xmm0, 01110010b
;	cadb7e8f
	pshufd xmm0, xmm0, 00100111b	; CDAB78EF
;	8fdb7eca	; for eax=ABCDEF78
	psrlq xmm0, 8	; shift right by one byte
	movdqa xmm1, xmm0
	andps xmm0, [edx+48]	; jq5 (andps performs a bitwise logical AND, SIMD Floating-Point Exceptions: none
	pcmpgtb xmm1, [edx+0]	; jq1 - get info which items are letters
	andps xmm1, [edx+16]	; jq2 - prepare for subtracting extra 7
	paddb xmm0, xmm1
	packuswb xmm0, xmm0	; pack words to bytes
		if 1
		movdqa xmm1, xmm0
		else
		movq xmm1, xmm0	; seems slower, at least on P4
		endif
	psrlq xmm0, 7*4	; interleave: shift right by seven nibbles
	orps xmm0, xmm1	; orps performs a bitwise logical OR, SIMD Floating-Point Exceptions: none
	movd eax, xmm0	; eax: abcdef78
	pop esi
	ret 4
Hex2BinSSE2c endp
Hex2BinSSE2c_endp:

movq_xmm1_edx		equ <dd 0A7E0FF3h>		; equates fix a masm 8+ bug
movq_xmm2_edx8	equ <db 0F3h, 0Fh, 7Eh, 52h, 8>
align 16
Hex2BinSSE2d_s:
jq1d	dq 3939393939393939h	; 8* "9"
jq2d	dq 0909090909090909h	; 8* 9
jq3d	dq 0F0F0F0F0F0F0F0Fh	; lowercase
Hex2BinSSE2d proc src
	mov edx, [esp+4]	; get the pointer
	movq_xmm1_edx	; movlps much slower on P4
	movdqa xmm0, xmm1
	mov edx, offset jq1d
	pcmpgtb xmm1, [edx+0]	; jq1 - get info which items are letters
	movq_xmm2_edx8	; load the extra 9 for letters
	andps xmm0, [edx+16]	; jq3 (andps performs a bitwise logical AND, SIMD Floating-Point Exceptions: none
	andps xmm1, xmm2	; jq2 - prepare for adding extra 9
	paddb xmm1, xmm0	; abcdef78
	xorps xmm0, xmm0	; xmm0 may contain garbage, no good for punpcklbw
	punpcklbw xmm0, xmm1	; expand 8 bytes to 8 xmm0 words
	pshuflw xmm0, xmm0, 01110010b	; see [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc265.htm]punpcklbw[/url] and [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc253.htm]pshuflw[/url]
	pshufhw xmm0, xmm0, 01110010b	; cadb
	pshufd xmm0, xmm0, 00100111b	; cadb7e8f
;	8fdb7eca	; for eax=ABCDEF78
	psrlq xmm0, 8	; shift right by one byte
	packuswb xmm0, xmm0	; pack words to bytes
		if 1	; one byte longer, not faster on P4
		movdqa xmm1, xmm0
		psrlq xmm0, 7*4	; interleave: shift right by seven nibbles
		orps xmm0, xmm1	; orps performs a bitwise logical OR, SIMD Floating-Point Exceptions: none
		movd eax, xmm0	; eax: abcdef78
		else
		movd eax, xmm0	; eax: _b_d_f_8
		psrlq xmm0, 7*4	; interleave: shift right by seven nibbles
		movd edx, xmm0	; edx: a_c_e_7_
		or eax, edx	; eax: abcdef78
		endif
	ret 4
Hex2BinSSE2d endp
Hex2BinSSE2d_endp:

movq_xmm1_eax		equ <dd 087E0FF3h>		; equates fix a masm 8+ bug
movq_xmm2_eax8	equ <db 0F3h, 0Fh, 7Eh, 50h, 8>
movq_xmm2_eax16	equ <db 0F3h, 0Fh, 7Eh, 50h, 16>
align 16
Hex2BinSSE2e_s:
jq1e	dq 3939393939393939h	; 8* "9"
jq2e	dq 0909090909090909h	; 8* 9
jq3e	dq 0F0F0F0F0F0F0F0Fh	; lowercase

Hex2BinSSE2e proc src
	mov eax, [esp+4]	; get the pointer
	movq_xmm1_eax	; movlps much slower on P4
	movdqa xmm0, xmm1
	mov eax, offset jq1e
	pcmpgtb xmm1, [eax]	; jq1 - get info which items are letters
	movq_xmm2_eax16
	pcmpgtb xmm2, xmm0	; compare packed bytes in [m128] and xmm0 for equality
	pmovmskb edx, xmm2	; set byte mask in eax for second 16 byte chunk
	movq_xmm2_eax8	; load the extra 9 for letters
	andps xmm0, [eax+16]	; jq3 (andps performs a bitwise logical AND, SIMD Floating-Point Exceptions: none
	andps xmm1, xmm2	; jq2 - prepare for adding extra 9
	paddb xmm1, xmm0	; abcdef78
	; xorps xmm2, xmm2
	xorps xmm0, xmm0	; xmm0 may contain garbage, no good for punpcklbw
	punpcklbw xmm0, xmm1	; expand 8 bytes to 8 xmm0 words
	pshuflw xmm0, xmm0, 01110010b	; see [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc265.htm]punpcklbw[/url] and [url=http://www.sesp.cse.clrc.ac.uk/html/SoftwareTools/vtune/users_guide/mergedProjects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc253.htm]pshuflw[/url]
	pshufhw xmm0, xmm0, 01110010b	; cadb
	pshufd xmm0, xmm0, 00100111b	; cadb7e8f
;	8fdb7eca	; for eax=ABCDEF78
	psrlq xmm0, 8	; shift right by one byte
	packuswb xmm0, xmm0	; pack words to bytes
	movdqa xmm1, xmm0
	psrlq xmm0, 7*4	; interleave: shift right by seven nibbles
	orps xmm0, xmm1	; orps performs a bitwise logical OR, SIMD Floating-Point Exceptions: none
	movd eax, xmm0	; eax: abcdef78
	test edx, edx
	je @F

	push ecx
	bsf ecx, edx	; bsf yields valid entries, e.g. 3
	neg ecx	; -3
	         test ecx, ecx
            cmove eax, ecx
	lea ecx, [4*ecx+32]	; +8, *4
	shr eax, cl	; shift them out
	pop ecx
@@:	ret 4
Hex2BinSSE2e endp
Hex2BinSSE2e_endp:

align 16
msk39h dq 3939393939393939H
mskFFh DQ 00FF00FF00FF00FFH
msk30h DQ 3030303030303030H
msk07h DQ 0707070707070707H
msk0Fh DQ 0F0F0F0F0F0F0F0FH
Hex2BinDrizzMMX_s:
Hex2BinDrizzMMX proc src
	mov eax,[esp+4]
	movq mm0,[eax]
	movq mm1,mm0
	pcmpgtb mm1,msk39h
	pand mm1,msk07h
	psubb mm0,msk30h
	psubb mm0,mm1
	pand mm0,msk0Fh
	movq mm1,mm0
	psllw mm1,4
	psrlw mm0,8
	por mm0,mm1
	pand mm0,mskFFh
	packuswb mm0,mm0
	movd eax,mm0
	bswap eax
;	emms
	ret 4
Hex2BinDrizzMMX endp
Hex2BinDrizzMMX_endp: 

Hex2BinDrizzSSE1_s:
Hex2BinDrizzSSE1 proc src
	mov eax,[esp+4]
	movq mm0,[eax]
	movq mm1,mm0
	pcmpgtb mm1,msk39h
	pand mm1,msk07h
	psubb mm0,msk30h
	psubb mm0,mm1
	pand mm0,msk0Fh
	movq mm1,mm0
	psllw mm1,4
	psrlw mm0,8
	por mm0,mm1
	pand mm0,mskFFh
	pshufw mm0,mm0,00011011b
	packuswb mm0,mm0
	movd eax,mm0
;	emms
	ret 4
Hex2BinDrizzSSE1 endp
Hex2BinDrizzSSE1_endp:

option prologue:none
option epilogue:none

ife UseLingoOLD
align 16
l_htodw_s:

l_htodw proc lpString:dword
mov edx, [esp+1*4]
push ebx
mov ebx, [edx]
xor ecx, ecx
add cl, bl
je End1
mov eax, [tabl8+ecx*4-0C0h]
xor ecx, ecx
add cl, bh
je End2
mov edx, [edx+4]
add eax, [tabl7+ecx*4-0C0h]
xor ecx, ecx
shr ebx, 16
add cl, bl
je End3
add eax, [tabl6+ecx*4-0C0h]
xor ecx, ecx
add cl, bh
je End4
add eax, [tabl5+ecx*4-0C0h]
xor ecx, ecx
add cl, dl
je End5
add eax, [tabl4+ecx*4-0C0h]
xor ecx, ecx
add cl, dh
je End6
add eax, [tabl3+ecx*4-0C0h]
pop ebx
shr edx, 16
xor ecx, ecx
add cl, dl
je End7
add eax, [tabl2+ecx*4-0C0h]
xor ecx, ecx
add cl, dh
je End8
add eax, [tabl1+ecx*4-0C0h]
ret 4
align 16
End1:
pop ebx
ret 4
align 16
End2:
shr eax, 28
pop ebx
ret 4
align 16
End3:
shr eax, 24
pop ebx
ret 4
align 16
End4:
shr eax, 20
pop ebx
ret 4
align 16
End5:
shr eax, 16
pop ebx
ret 4
align 16
End6:
shr eax, 12
pop ebx
ret 4
align 16
End7:
shr eax, 8
ret 4
align 16
End8:
shr eax, 4
ret 4
align 16
tabl1 dd 0,1,2,3,4,5,6,7,8,9
	dd 7 Dup(0)
	dd 0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh
	dd 26 Dup(0)
	dd 0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh
align 16
tabl2 dd 0,1*10h,2*10h,3*10h,4*10h,5*10h,6*10h,7*10h,8*10h,9*10h
	dd 7 Dup(0)
	dd 0Ah*10h, 0Bh*10h,0Ch*10h,0Dh*10h,0Eh*10h,0Fh*10h
	dd 26 Dup(0)
	dd 0Ah*10h, 0Bh*10h,0Ch*10h,0Dh*10h,0Eh*10h,0Fh*10h
align 16
tabl3 dd 0,1*10h*10h,2*10h*10h,3*10h*10h,4*10h*10h,5*10h*10h,6*10h*10h,7*10h*10h,8*10h*10h,9*10h*10h
	dd 7 Dup(0)
	dd 0Ah*10h*10h, 0Bh*10h*10h,0Ch*10h*10h,0Dh*10h*10h,0Eh*10h*10h,0Fh*10h*10h
	dd 26 Dup(0)
	dd 0Ah*10h*10h, 0Bh*10h*10h,0Ch*10h*10h,0Dh*10h*10h,0Eh*10h*10h,0Fh*10h*10h
align 16
tabl4 dd 0,1*10h*10h*10h,2*10h*10h*10h,3*10h*10h*10h,4*10h*10h*10h,5*10h*10h*10h,6*10h*10h*10h,7*10h*10h*10h,8*10h*10h*10h,9*10h*10h*10h
	dd 7 Dup(0)
	dd 0Ah*10h*10h*10h, 0Bh*10h*10h*10h,0Ch*10h*10h*10h,0Dh*10h*10h*10h,0Eh*10h*10h*10h,0Fh*10h*10h*10h
	dd 26 Dup(0)
	dd 0Ah*10h*10h*10h, 0Bh*10h*10h*10h,0Ch*10h*10h*10h,0Dh*10h*10h*10h,0Eh*10h*10h*10h,0Fh*10h*10h*10h
align 16
tabl5 dd 0,1*10h*10h*10h*10h,2*10h*10h*10h*10h,3*10h*10h*10h*10h,4*10h*10h*10h*10h,5*10h*10h*10h*10h,6*10h*10h*10h*10h,7*10h*10h*10h*10h,8*10h*10h*10h*10h,9*10h*10h*10h*10h
	dd 7 Dup(0)
	dd 0Ah*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h,0Ch*10h*10h*10h*10h,0Dh*10h*10h*10h*10h,0Eh*10h*10h*10h*10h,0Fh*10h*10h*10h*10h
	dd 26 Dup(0)
	dd 0Ah*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h,0Ch*10h*10h*10h*10h,0Dh*10h*10h*10h*10h,0Eh*10h*10h*10h*10h,0Fh*10h*10h*10h*10h
align 16
tabl6 dd 0,1*10h*10h*10h*10h*10h, 2*10h*10h*10h*10h*10h, 3*10h*10h*10h*10h*10h
	dd 4*10h*10h*10h*10h*10h, 5*10h*10h*10h*10h*10h, 6*10h*10h*10h*10h*10h, 7*10h*10h*10h*10h*10h, 8*10h*10h*10h*10h*10h, 9*10h*10h*10h*10h*10h
	dd 7 Dup(0)
	dd 0Ah*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h
	dd 26 Dup(0)
	dd 0Ah*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h
align 16
tabl7 dd 0,1*10h*10h*10h*10h*10h*10h,2*10h*10h*10h*10h*10h*10h,3*10h*10h*10h*10h*10h*10h
	dd 4*10h*10h*10h*10h*10h*10h,5*10h*10h*10h*10h*10h*10h,6*10h*10h*10h*10h*10h*10h,7*10h*10h*10h*10h*10h*10h,8*10h*10h*10h*10h*10h*10h,9*10h*10h*10h*10h*10h*10h
	dd 7 Dup(0)
	dd 0Ah*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h
	dd 26 Dup(0)
	dd 0Ah*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h
align 16
tabl8 dd 0,1*10h*10h*10h*10h*10h*10h*10h,2*10h*10h*10h*10h*10h*10h*10h,3*10h*10h*10h*10h*10h*10h*10h,4*10h*10h*10h*10h*10h*10h*10h
	dd 5*10h*10h*10h*10h*10h*10h*10h,6*10h*10h*10h*10h*10h*10h*10h,7*10h*10h*10h*10h*10h*10h*10h,8*10h*10h*10h*10h*10h*10h*10h,9*10h*10h*10h*10h*10h*10h*10h
	dd 7 Dup(0)
	dd 0Ah*10h*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h*10h
	dd 26 Dup(0)
	dd 0Ah*10h*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h*10h
l_htodw endp
l_htodw_endp:
endif

align 16
Hex2dwLingoSSE_s:
Hex2dwLingoSSE proc src
	pop edx
	pop eax
	pshufw mm0,[eax], 01Bh
	   movq	 mm2, mask30h
	   ;pxor	 mm2, mm2
	pshufw mm1,mm0, 0E4h
	paddb mm0, maskD0h
	pcmpgtb mm1,mask39h
	   pcmpgtb mm2,[eax]
	   ;pcmpeqb mm2, [eax]	
	pand mm1,maskF9h
	paddb mm0,mm1
	pand mm0,mask0Fh
	pshufw mm1,mm0, 0E4h
	psrlw mm0,8
	psllw mm1,4
	pmovmskb ecx, mm2
	por mm0,mm1
	pand mm0,maskFFh
	packuswb mm0,mm0
	test		ecx, ecx			
	movd	eax,mm0
	jne		@f
	jmp		edx
	tbls db 31,28,24,20,16,12,8,4
align 16
@@:
	bsf		ecx, ecx 
	movzx	ecx, byte ptr [tbls+ecx]	
	shr		eax, cl
	jmp		edx
Hex2dwLingoSSE endp
Hex2dwLingoSSE_endp:
option prologue:prologuedef
option epilogue:epiloguedef

end start

OPT_Tmp2Asm	1
OPT_Assembler	mlv615
OPT_Olly	2
OPT_Res	0
